/**************************************************************************
***    
*** Copyright (c) 1995-2000 Regents of the University of California,
***               Andrew E. Caldwell, Andrew B. Kahng and Igor L. Markov
***
***  Contact author(s): abk@cs.ucla.edu, imarkov@cs.ucla.edu
***  Affiliation:   UCLA, Computer Science Department,
***                 Los Angeles, CA 90095-1596 USA
***
***  Permission is hereby granted, free of charge, to any person obtaining 
***  a copy of this software and associated documentation files (the
***  "Software"), to deal in the Software without restriction, including
***  without limitation 
***  the rights to use, copy, modify, merge, publish, distribute, sublicense, 
***  and/or sell copies of the Software, and to permit persons to whom the 
***  Software is furnished to do so, subject to the following conditions:
***
***  The above copyright notice and this permission notice shall be included
***  in all copies or substantial portions of the Software.
***
*** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
*** EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
*** OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
*** IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
*** CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
*** OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
*** THE USE OR OTHER DEALINGS IN THE SOFTWARE.
***
***
***************************************************************************/




//created by Igor Markov on 06/07/98

#ifndef __STRAYNODES2WAY_H__
#define __STRAYNODES2WAY_H__

#include <iostream.h>
#include "talliesWCosts2way.h"

static const unsigned forDefaultStrayNodes2TerminalsCountAs=2;

class StrayNodes2way : public TalliesWCosts2way
{
   void reinitializeProper();
   unsigned _maxNetCost;
public:

  StrayNodes2way(const PartitioningProblem& problem, const Partitioning& part,
                unsigned terminalsCountAs=forDefaultStrayNodes2TerminalsCountAs)
       : TalliesWCosts2way(problem,part,terminalsCountAs),_maxNetCost(UINT_MAX)
  { reinitializeProper(); }

  StrayNodes2way(const PartitioningProblem& problem,
                unsigned terminalsCountAs=forDefaultStrayNodes2TerminalsCountAs)
       : TalliesWCosts2way(problem,terminalsCountAs),_maxNetCost(UINT_MAX)
  {}

  StrayNodes2way(const HGraphFixed& hg, const Partitioning& part,
                unsigned terminalsCountAs=forDefaultStrayNodes2TerminalsCountAs)
                 : TalliesWCosts2way(hg,part,terminalsCountAs)
  { reinitializeProper(); }

  void reinitialize() { TalliesWCosts2way::reinitialize();reinitializeProper();}

  unsigned getMaxCostOfOneNet() const  { return _maxNetCost; }

  virtual inline unsigned computeCostOfOneNet(unsigned netIdx) const
  {
    unsigned short *pt=_tallies + 2*netIdx;
    return min(*pt,*(pt+1));
  }
};


#endif
